package fineday.TCPAndroid;

import android.app.Activity;
import android.os.Bundle;

import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import java.io.IOException;
import java.io.OutputStream;
import java.net.Socket;

public class TCPAndroidActivity extends Activity implements View.OnClickListener{
	private TextView textview1;
	private Button button1, button2, button3;
	private EditText edittext1;
	private String server = "192.168.11.5";
	private int port = 8000;
	private Socket socket;
	private OutputStream out;
	private Thread rcvThread;
	public Logger logger;
	
	final char magic1 = '}';
	final char magic2 = '{';
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.main);
        textview1 = (TextView)this.findViewById(R.id.textView1);
        textview1.setText("TCPAndroid");
        // Button
        button1 = (Button)this.findViewById(R.id.button1);
        button1.setOnClickListener(this);
        button2 = (Button)this.findViewById(R.id.button2);
        button2.setOnClickListener(this);
        button3 = (Button)this.findViewById(R.id.button3);
        button3.setOnClickListener(this);
        // EditText
        edittext1 = (EditText)this.findViewById(R.id.editText1);
        logger = new Logger(textview1);
    }

    public void onClick(View arg0){
    	// ڑ
    	if (arg0 == button1){
    		try{
    			socket = new Socket(server, port);
    			out = socket.getOutputStream();
        		logger.log("Connected");
    	    	rcvThread = new Thread(new rcvThread(logger, socket));
    		    rcvThread.start();
    		    logger.log("rcvThread started");
   		    } catch (Exception e){
   		    	logger.log("fail connect");
    		}
    	}
    	// I
    	if (arg0 == button2){
    		exitFromRunLoop();
    		try{
    			socket.close();
    			socket = null;
    	    	logger.log("closed");
    		    rcvThread.stop();
    		    rcvThread = null;
    		} catch (Exception e) {
    			logger.log("fail close");
    		}
    	}
    	// M
    	if (arg0 == button3){
    		try {
				byte[] w = edittext1.getText().toString().getBytes("UTF8");
				out.write(w);
				out.flush();
			} catch (IOException e) {
				logger.log("send fail");
				e.printStackTrace();
			}
    	}
    }
    // Run[vEo
    void exitFromRunLoop(){
    	try {
    		byte[] w = new byte[2];
    		w[0] = magic1;
    		w[1] = magic2;
    		out.write(w);
    		out.flush();
    	} catch (IOException e) {
    		logger.log("send fail");
    		e.printStackTrace();
    	}
    }
}
