package fineday.TCPAndroidUI;

import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;

import android.view.View;
import android.view.Window;
import android.widget.Button;
//import android.widget.EditText;
import android.widget.TextView;

import java.io.IOException;
import java.io.OutputStream;
import java.net.Socket;

public class TCPAndroidUIActivity extends Activity implements View.OnClickListener{
	private TextView textview1,textview2;
	private Button button1, button2, button7, button8, button9, button10;
	private Button[] button = new Button[4];
	private String server = "192.168.11.4";
	private int port = 8000;
	private Socket socket;
	private OutputStream out;
	private Thread rcvThread;
	public Logger logger;
	
	final char magic1 = '}';
	final char magic2 = '{';
	private String[] st = {"~", "~", "~", "~", "~", "~"};
	private String str = "        "+st[0]+"\n   "+st[3]+"        "+st[1]+"    "+st[4]+"    "+st[5]+"\n        "+st[2]+"\n";
	private boolean[] btState = {false, false, false, false};
	private String[] cmdReverse = {"@r1", "@r2", "@r3", "@r4"};
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.main);
        // TextView
        textview1 = (TextView)this.findViewById(R.id.textView1);
        textview2 = (TextView)this.findViewById(R.id.textView2);
        textview1.setText("TCPAndroid");
        textview2.setText(str);
        // Button
        button1 = (Button)this.findViewById(R.id.button1);
        button1.setOnClickListener(this);
        button2 = (Button)this.findViewById(R.id.button2);
        button2.setOnClickListener(this);
        button[0] = (Button)this.findViewById(R.id.button3);
        button[0].setOnClickListener(this);
        button[1] = (Button)this.findViewById(R.id.button4);
        button[1].setOnClickListener(this);
        button[2] = (Button)this.findViewById(R.id.button5);
        button[2].setOnClickListener(this);
        button[3] = (Button)this.findViewById(R.id.button6);
        button[3].setOnClickListener(this);
        button7 = (Button)this.findViewById(R.id.button7);
        button7.setOnClickListener(this);
        button8 = (Button)this.findViewById(R.id.button8);
        button8.setOnClickListener(this);
        button9 = (Button)this.findViewById(R.id.button9);
        button9.setOnClickListener(this);
        button10 = (Button)this.findViewById(R.id.button10);
        button10.setOnClickListener(this);
        logger = new Logger(textview1, textview2);
    }

    public void onClick(View arg0){
    	// ڑ
    	if (arg0 == button1){
    		try{
    			socket = new Socket(server, port);
    			out = socket.getOutputStream();
    	    	rcvThread = new Thread(new rcvThread(logger, socket));
    		    rcvThread.start();
    		    button1.setBackgroundColor(Color.GREEN);
    		    // LEDݒ
    		    for (int i = 1; i < 4; i++) {
    		    	btState[i] = false;
    		    	button[i].setBackgroundColor(Color.GRAY);
    		    }
    			sendCommand("@ac");
    			logger.log("Initialized");
   		    } catch (Exception e){
   		    	logger.log("fail connect");
   		    }
    	}
    	// ؒf
    	if (arg0 == button2){
    		exitFromRunLoop();
    		try{
    			socket.close();
    			socket = null;
    	    	logger.log("Closed");
    	    	button1.setBackgroundColor(Color.WHITE);
    		    rcvThread.stop();
    		    rcvThread = null;
    		} catch (Exception e) {
    			logger.log("fail close");
    		}
    	}
    	// LEDR}h
    	for (int i = 0; i < 4; i++) {
    		if (arg0 == button[i]){
    			if (btState[i]) {
    				button[i].setBackgroundColor(Color.WHITE);
    			} else {
    				button[i].setBackgroundColor(Color.RED);
    			}
    			btState[i] = !btState[i];
    			sendCommand(cmdReverse[i]);
    		}
    	}
    	// LEDS_
		if (arg0 == button7){
			for (int i = 1; i < 4; i++) {
				btState[i] = true;
				button[i].setBackgroundColor(Color.RED);
			}
			sendCommand("@as");
		}
		// LEDS
		if (arg0 == button8){
			for (int i = 1; i < 4; i++) {
				btState[i] = false;
				button[i].setBackgroundColor(Color.WHITE);
			}
			sendCommand("@ac");
		}
		// LEDS]
		if (arg0 == button9){
			for (int i = 1; i < 4; i++) {
    			if (btState[i]) {
    				button[i].setBackgroundColor(Color.WHITE);
    			} else {
    				button[i].setBackgroundColor(Color.RED);
    			}
				btState[i] = !btState[i];
			}
			sendCommand("@ar");
		}
		if (arg0 == button10) {
			sendCommand("@w");
		}
    }
    // mbedփR}hM
    void sendCommand(String str) {
		try {
			byte[] w = str.getBytes("UTF8");
			out.write(w);
			out.flush();
		} catch (IOException e) {
			logger.log("send fail");
			e.printStackTrace();
		}

    }
    // Run[vEo
    void exitFromRunLoop(){
    	try {
    		byte[] w = new byte[2];
    		w[0] = magic1;
    		w[1] = magic2;
    		out.write(w);
    		out.flush();
    	} catch (IOException e) {
    		logger.log("send fail");
    		e.printStackTrace();
    	}
    }
}
